# Filter

- filter_0: placeholder code, copies input into output
- filter_1: straightforward implementation
- filter_2: removed difficult-to-predict branch
- filter_3: using lookup table

# Matrix multiplication

At 8192x8192 fp64 on 7900x3d (24 threads):

- matmul_0: placeholder code, sets X to 0               0.663
- matmul_1: straightforward implementation           2932.059
- matmul_2: transpose B matrix                        357.569    8x
- matmul_3: block multiply                             67.105   44x
- matmul_4: same code as matmul_3, -march=native       32.876   89x
- matmul_5: OpenBLAS                                   15.555  188x
- matmul_6: OpenBLAS, 24 threads                        1.962 1494x (8x prev)

At 32768x32768 fp32:

- matmul_7: OpenBLAS, 1 thread, 7900x3d               550.350
- matmul_8: OpenBLAS, 24 threads, 7900x3d              50.577   11x
- matmul_9: cuBLAS, nVidia A10G                        13.152   42x
- matmul_9: cuBLAS, nVidia A100 (p4d.24xlarge)

## Discarded attempts

At 8192x8192 fp64 on 7R32 (8 virtual threads / 96):

- matmul_4: same code as matmul_3, -march=native       73.410
- matmul_6: using OpenBLAS, 8 threads                   6.634

At 32768x32768 fp32:

- matmul_7: OpenBLAS, 8 threads, 7R32                 187.806
- matmul_7: OpenBLAS, 8 threads, 7R32                 187.806
- matmul_7: OpenBLAS, 24 threads, 7900x3d              49.497
- matmul_8: cuBLAS, nVidia A10G                        13.152

