#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include "util.h"
#include "avg_b.h"

void averages_B(int *buff, int size, double *avg_pos, double *avg_neg)
{
	int64_t total[4] = { 0, 0, 0, 0 };
	int64_t count[4] = { 0, 0, 0, 0 };

	for (int i = 0; i < size; i++) {
		int v = buff[i];

		int pos_bit = ((-v) >> 31) & 1;
		int neg_bit = (v >> 30) & 2;

		total[pos_bit + neg_bit] += v;
		count[pos_bit + neg_bit] += 1;
	}

	DEBUG("2: totals %10ld %12ld pos, %10ld %12ld neg\n",
		count[1], total[1], count[2], total[2]);
	*avg_pos = (double)total[1] / count[1];
	*avg_neg = (double)total[2] / count[2];
}

