#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include "util.h"
#include "avg_c.h"

void averages_C(int *buff, int size, double *avg_pos, double *avg_neg)
{
	int64_t total_pos = 0, total_neg = 0;
	int64_t count_pos = 0, count_neg = 0;

	for (int i = 0; i < size; i++) {
		int v = buff[i];

		int pos_mask = (-v) >> 31;
		int neg_mask = v >> 31;

		total_pos += v & pos_mask;
		count_pos += 1 & pos_mask;
		total_neg += v & neg_mask;
		count_neg += 1 & neg_mask;
	}

	DEBUG("3: totals %10ld %12ld pos, %10ld %12ld neg\n",
		count_pos, total_pos, count_neg, total_neg);
	*avg_pos = (double)total_pos / count_pos;
	*avg_neg = (double)total_neg / count_neg;
}
